//===================================//
//         Error Demo2.CPP           //
//===================================//

#include <windows.h>
#include "LocalError2.h"
#include "resource.h"

HKEY	hAppKey;

void OpenRegistryKey()
{
	DWORD	dwResult;

	// open (or create) a registry key where the error log path
	// and file name will be found ... use the app name to identify
	// the log location for this specific application only

	RegCreateKeyEx( HKEY_LOCAL_MACHINE,						// primary key
					"Software\\Error Logs\\Error Demo2",	// subkey name 
 					0,							// reserved 
					NULL,						// address of class string 
 					REG_OPTION_NON_VOLATILE,	// special options flag (default)
					KEY_ALL_ACCESS,				// desired security access 
					NULL,						// address of key security structure 
					&hAppKey,					// address of buffer for opened handle 
					&dwResult );				// address of disposition value buffer 
	if( dwResult == REG_CREATED_NEW_KEY )
	{
		char szDirPath[_MAX_PATH];

		// Because this is a new registry entry, we need to set
		// an error log path and file name entry

		GetCurrentDirectory( _MAX_PATH, (LPSTR) szDirPath );
		strcat( szDirPath, "\\Error Demo2.LOG" );
		RegSetValueEx( hAppKey,					// handle of key to set value for 
					   "Error Log Name",		// address of value to set 
					   0,						// reserved 
					   REG_SZ,					// flag for value type 
			   (BYTE *)szDirPath,				// address of value data 
			(lstrlen(szDirPath)+1)*sizeof(TCHAR) );	        // size of value data 
	}
}

long APIENTRY WndProc( HWND hwnd,   UINT msg,
                       UINT wParam, LONG lParam )
{
	ERRORMSG2	errMsg2;
	char		szCaption[100], szErrStr[1000];
	POINT		point;

	switch( msg )
	{
		case WM_CREATE:
			OpenRegistryKey();
			break;

		case WM_COMMAND:
			switch( LOWORD( wParam ) )
			{
				case IDM_USER_MESSAGE:
					strcpy( szErrStr, "This is an error report|This is explanation text|And this is the suggested response" );
					errMsg2.pszErrorString = &szErrStr[0];
					errMsg2.nErrorCode = 101;
					errMsg2.ErrorType = USER_ERROR;
					szCaption[0] = '\0';
					ReportErrorStd2( errMsg2, hAppKey, 0, szCaption );
					break;

				case IDM_POPUP:
					point.x = 100;
					point.y = 100;
					strcpy( szErrStr, "This is a popup message" );
					errMsg2.pszErrorString = &szErrStr[0];
					errMsg2.nErrorCode = 101;
					errMsg2.ErrorType = USER_ERROR;
					ReportPopup2( errMsg2, 0, point, 0 );
					break;
			}
			break;

		case WM_DESTROY:			// message: window being destroyed 
			PostQuitMessage(0);
			break;

		default:					// if msg unproccessed, return to Windows 
			return( DefWindowProc( hwnd, msg, wParam, lParam ) );
	}
	return TRUE;
}

int APIENTRY WinMain( HINSTANCE  hInstance,    HINSTANCE hPrevInstance,
                      LPSTR  lpszCmdParam, int    nCmdShow )
{
	static char szAppName[] = "Error Demo2";
	HWND        hwnd;
	MSG         msg;
	WNDCLASS    wc;

	if( ! hPrevInstance )
	{
		wc.style         = CS_HREDRAW | CS_VREDRAW;
		wc.lpfnWndProc   = WndProc;
		wc.cbClsExtra    = 0;
		wc.cbWndExtra    = 0;
		wc.hInstance     = hInstance;
		wc.hIcon         = LoadIcon( NULL, IDI_APPLICATION );
		wc.hCursor       = LoadCursor( NULL, IDC_ARROW );
		wc.hbrBackground = (HBRUSH) GetStockObject( WHITE_BRUSH );
		wc.lpszMenuName  = "ERRORDEMO2MENU";
		wc.lpszClassName = szAppName;
		RegisterClass( &wc );
	}
	hwnd = CreateWindow(
		szAppName,					// window class name       
		"Error Demo2",				// window caption          
		WS_OVERLAPPEDWINDOW,		// window style            
		100,						// initial X position      
		100,						// initial Y position      
		300,						// initial X size          
		200,						// initial Y size          
		NULL,						// parent window handle    
		NULL,						// window menu handle      
		hInstance,					// program instance handle 
		NULL  );					// creation parameters     
	ShowWindow( hwnd, nCmdShow );
	UpdateWindow( hwnd );
	while( GetMessage( &msg, NULL, 0, 0 ) )
	{
		TranslateMessage( &msg );
		DispatchMessage( &msg );
	}
	return msg.wParam;
}
