VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CUserPref"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' API Declarations
Private Declare Function RegCloseKey Lib "advapi32.dll" _
        (ByVal hKey As Long) As Long
Private Declare Function RegCreateKey Lib "advapi32.dll" _
        Alias "RegCreateKeyA" _
        (ByVal hKey As Long, ByVal lpSubKey As String, _
        phkResult As Long) As Long
Private Declare Function RegQueryValueEx Lib "advapi32.dll" _
        Alias "RegQueryValueExA" _
        (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Any, _
        lpcbData As Long) As Long
Private Declare Function RegSetValueEx Lib "advapi32.dll" _
        Alias "RegSetValueExA" _
        (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpData As Any, _
        ByVal cbData As Long) As Long
Private Declare Function FormatMessage Lib "kernel32" _
        Alias "FormatMessageA" _
        (ByVal dwFlags As Long, lpSource As Any, _
        ByVal dwMessageId As Long, ByVal dwLanguageId As Long, _
        ByVal lpBuffer As String, ByVal nSize As Long, _
        Arguments As Long) As Long
        
' API Constants
Private Const HKEY_CURRENT_USER = &H80000001
Private Const ERROR_SUCCESS = 0&
Private Const FORMAT_MESSAGE_FROM_SYSTEM = &H1000
Private Const REG_SZ = 1

' Enumerated Type
Public Enum Style
    TRADITIONAL = 0
    MODERN = 1
End Enum

' Class private variables
Private blnRegistry As Boolean
Private hKey As Long
Private strValue As String, strUserPref As String
Private lngStyle As Style
Private Sub Class_Initialize()

Dim lngRegError As Long, lngBuffer As Long
Dim strKey As String, strBuffer As String

blnRegistry = True
strKey = "Software\MyApp"
strValue = "Style"
strBuffer = String(32, 0)
lngBuffer = Len(strBuffer)

Call RegCreateKey(HKEY_CURRENT_USER, strKey, hKey)

lngRegError = RegQueryValueEx(hKey, strValue, 0, ByVal 0, _
              ByVal strBuffer, lngBuffer)
If lngRegError = ERROR_SUCCESS Then
   If Left(strBuffer, lngBuffer - 1) = "MODERN" Then
      lngStyle = MODERN
   Else
      lngStyle = TRADITIONAL
   End If
Else
   ReportError lngRegError
   lngStyle = TRADITIONAL
   blnRegistry = False
End If

If Not blnRegistry Then SaveStartup

End Sub

Private Sub Class_Terminate()

SaveStartup
Call RegCloseKey(hKey)

End Sub



Private Sub ReportError(lngErrCode As Long)
 
#If vbdebug Then
   Dim lngSize As Long
   Dim strBuffer As String
   
   strBuffer = String(256, 0)
   lngSize = FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, _
             ByVal 0, lngErrCode, 0, strBuffer, _
             Len(strBuffer), ByVal 0)
   Call MsgBox("Error " & lngErrCode & ": " & _
          Left(strBuffer, lngSize), vbCritical Or vbOKOnly, _
          "Error Report")
#End If

End Sub

Private Sub SaveStartup()

Dim strStyle As String

If lngStyle = MODERN Then
   strStyle = "MODERN"
Else
   strStyle = "TRADITIONAL"
End If

Call RegSetValueEx(hKey, strValue, 0, REG_SZ, _
                   ByVal strStyle, Len(strStyle) + 1)

End Sub

Public Property Get Style() As String

If lngStyle = MODERN Then
   Style = "MODERN"
Else
   Style = "TRADITIONAL"
End If

End Property

Public Property Let Style(ByVal vNewValue As String)

If vNewValue = "MODERN" Then
   lngStyle = MODERN
Else
   lngStyle = TRADITIONAL
End If

End Property
